#
# Description: <Method description here>
#
begin
  ## Set the serivce_template_provision_task
  stp_task = $evm.root['service_template_provision_task']
  raise "Failed to set stp_task" if stp_task.nil?  
  
  @debug=stp_task.options[:debug]
  
  require 'restclient'
  require 'rexml/document'

  ## Instantiate local vars
  cookie = nil
  
  ## UCS credentials pulled from schema
  ucs_user = $evm.object['ucs_user']
  ucs_pw   = $evm.object.decrypt('ucs_pw')
  $evm.log(:info,"PROV_LOG_DEBUG- ucs_user:#{ucs_user} ucs_pw:######" ) if @debug
  
  ## Obtain vars from root
  ucs_mgr = stp_task.options[:ucs_manager]
  rhevh_name = stp_task.options[:rhevh_name]
  
  ## Construct the restclient object to use for connecting to ucs
  ucs_conn = RestClient::Resource.new( "https://#{ucs_mgr}", :ssl_version => 'TLSv1', :verify_ssl => false, :content_type => 'text/xml' )

  ## login to UCS and retrieve the session cookie
  $evm.log(:info,"PROV_LOG_DEBUG- Logging in to UCS: #{ucs_mgr}") if @debug
  begin
    resp = ucs_conn['/nuova'].post(
      "<aaaLogin inName='#{ucs_user}' inPassword='#{ucs_pw}'/>" )
      $evm.log(:info,"PORV_LOG_DEBUG- UCS Login response: #{resp}") if @debug      
      cookie = REXML::Document.new(resp).root.attributes['outCookie']
  rescue => e
    $evm.log(:error, "Failed to login to #{ucs_mgr}:[#{e}]")
  end
  ## set the UCS login cookie
  $evm.log(:info,"PROV_LOG_DEBUG- UCS session cookie: #{cookie}") if @debug
  stp_task.set_option(:ucs_cookie, cookie)

rescue => err
  $evm.log(:error, "Caught exception in ucs_login:#{err.class}:#{err}")
end
