#
# Description: <Method description here>
#
begin
  ## Set the serivce_template_provision_task
  stp_task = $evm.root['service_template_provision_task']
  raise "Failed to set stp_task" if stp_task.nil?  
  @debug=stp_task.options[:debug]
  
  require 'restclient'
  require 'rexml/document'
  
  ## Obtain vars from root
  ucs_mgr = stp_task.options[:ucs_manager]
  cookie = stp_task.options[:ucs_cookie]
  
  ## Construct the restclient object to use for connecting to ucs
  ucs_conn = RestClient::Resource.new( "https://#{ucs_mgr}", :ssl_version => 'TLSv1', :verify_ssl => false, :content_type => 'text/xml' )

  ## login to UCS and retrieve the session cookie
  unless cookie.eql?(nil)
    $evm.log(:info,"PROV_LOG_DEBUG- Logging out of UCS: #{ucs_mgr}") if @debug
    begin
      ucs_conn['/nuova'].post(
       "<aaaLogout inCookie='#{cookie}'/>" )
    rescue => e
      $evm.log(:error, "PROV_LOG- Failed to logout from #{ucs_mgr}:[#{e}]")
    end
  end
rescue => err
  $evm.log(:error, "Caught exception in ucs_logout:#{err.class}:#{err}")
end
