#
# Description: this method will obtain the suitable networks
#
begin
  
  @debug= $evm.object['debug']
  ## Obtain the redhat host from the dialog 	
  cluster_id = $evm.object['dialog_cluster_name'] || nil
  
  # Preset vars
  nfs_network = ""

  ## Determine if host_id is not nil and if not then set dropdown, otherwise set default val
  if !cluster_id.eql?(nil)
    $evm.log(:info, "cluster ID: #{cluster_id}") if @debug

    #get cluster object for the selected cluster
    redhat_cluster = $evm.vmdb('ems_cluster').find_by_id(cluster_id)

    ## Get a list of hosts in the cluster
    hosts = redhat_cluster.hosts
    
    ## Loop through the hosts and pull the one that was last created
    hosts.delete_if {|obj| obj.power_state != "on"}
    hosts.sort_by! {|a| a.created_on}
    template_host = hosts[0]  
  
    ## Set the vlans based on the host selected
    if template_host
      template_host.lans.each { |network|
        if network.name =~ /nfs/
          nfs_network = "#{network.name}"
          $evm.log(:info, "network: #{network.name}") if @debug
        end
      }
    end
  end
  
  $evm.object['required'] = true  
  $evm.object['read_only'] = true
  $evm.object['value'] = nfs_network
 
rescue => err
  (dbtype_hash||={})["#{err.class}: #{err}"] = "#{err.class}: #{err}"
  $evm.object['value'] = dbtype_hash
  $evm.log(:error, "ERROR: #{$evm.object['value']}")    
end 
