#
# Description: this method will obtain hostname the next hostname
#
begin
  
  @debug= $evm.object['debug']
  
  ## Obtain the redhat cluster from the dialog  	
  cluster_id = $evm.object['dialog_cluster_name']

  ## Determine if cluster_id is null and set default value if it is
  if !cluster_id.eql? nil
    $evm.log(:info, "cluster ID: #{cluster_id}") if @debug

    #get cluster object for the selected cluster
    redhat_cluster = $evm.vmdb('ems_cluster').find_by_id(cluster_id)
  
    if redhat_cluster
      ## obtain last host base on name
      last_host = redhat_cluster.hosts.sort { |a,b| a.name <=> b.name }.last
      last_host_name = last_host.name.split('.')[0]
      last_host_number = last_host_name[/([0-9]+)/].to_i
      last_host_substr = last_host_name[/([a-z]+)/]
    
      ## Determine the next number
      next_host_number = last_host_number + 1
      
      ## Set the host
      next_host = "#{last_host_substr}#{next_host_number}"
    end
  else
    ## Set default for host
    next_host = ''  
  end

  list_values = {
    'required' => true,
    'protected' => false,
    'read_only' => false,
    'value' => next_host,
  }

  list_values.each do |key, value|
    $evm.log(:info, "Setting dialog variable #{key} to #{value}") if @debug
    $evm.object[key] = value
  end

rescue => err
  (dbtype_hash||={})["#{err.class}: #{err}"] = "#{err.class}: #{err}"
  $evm.object['value'] = dbtype_hash
  $evm.log(:error, "ERROR: Dynamic value: #{$evm.object['value']}")    
end 
