#
# Description: Place holder for Service Provision Complete email #
#
#
begin
task = $evm.root['service_template_provision_task'] || $evm.root['automation_task']

rhevh_name = $evm.root['dialog_rhevh_name']

if !rhevh_name.nil?

  
  to = nil
  to = $evm.root['user'].email
  to ||= $evm.object['to_email_address']
  if to.nil?
    $evm.log("info", "Email not sent because no recipient specified.")
    exit MIQ_OK
  end

  # Get from_email_address from model unless specified below
  from = nil
  from ||= $evm.object['from_email_address']

  # Get signature from model unless specified below
  signature = "ESS-Enterprise Server Engineering(ESE) Team"
  signature ||= $evm.object['signature']

  subject = "Your Rhev Host request has Completed - Host: #{rhevh_name}"

  body = "Greetings, "

  # Email Body 
  body += "<br><br>Your request to provision a Rhev Host:#{rhevh_name} was approved and completed on #{Time.now.strftime('%A, %B %d, %Y at %I:%M%p')}. "

  #Configuration details
  
  provider_id = $evm.root['dialog_src_ems_id']
  provider = $evm.vmdb(:ext_management_system).find_by_id(provider_id).name
  cluster_id = $evm.root['dialog_cluster_name']
  cluster = $evm.vmdb('ems_cluster').find_by_id(cluster_id).name
  ip ="No"
  if $evm.root['dialog_ips_registered_in_infoblox'] == 'f'  
    ip = "No"
  else
    ip ="Yes"
  end
  
  ucs_blade =""
  if defined?($evm.root['dialog_ucs_blade'])
    ucs_blade = "<tr><td>UCS Blade:</td><td> #{$evm.root['dialog_ucs_blade']}</td></tr>"
  end  
  
  table = <<-eos 
  <br><br><table border=1 cellpadding=0 cellspacing=0>
  <tr><td>IP already registered<br>in infoblox:</td><td> #{ip}</td></tr>  
  <tr><td>RHEV Provider:</td><td> #{provider}</td></tr>  
  <tr><td>Network Location:</td><td> #{$evm.root['dialog_network_location']}</td></tr>
  <tr><td>Environment:</td><td> #{$evm.root['dialog_environment']}</td></tr>
  <tr><td>RHEV Cluster:</td><td> #{cluster}</td></tr> 
  #{ucs_blade}	
  <tr><td>Host Name:</td><td> #{rhevh_name}</td></tr> 
  <tr><td>OS Release:</td><td> #{$evm.root['dialog_os_version']}</td></tr>  
  <tr><td>RHEV Primary Vlan:</td><td> #{$evm.root['dialog_primary_vlan']}</td></tr>   
  <tr><td>NFS Vlan:</td><td> #{$evm.root['dialog_nfs_vlan']}</td></tr>  
  <tr><td>UCS Service Profile Template:</td><td> #{$evm.root['dialog_ucs_sp_template']}</td></tr>  
  </table>
  eos

  body += "#{table}"
 
  body += "<br><br> Thank you,"
  body += "<br> #{signature}"
       
  $evm.log("info", "Sending email to <#{to}> from <#{from}> subject: <#{subject}>")
  $evm.execute('send_email', to, from, subject, body)
  
end
 
rescue => err
	$evm.log(:error, "ERROR: Sending Email: #{err.class}: #{err}")
end
 
