#
# Description: this method will determine if the hypervisor has shown up in cloudforms
#
begin
  
  ## Set the serivce_template_provision_task
  stp_task = $evm.root['service_template_provision_task']
  raise "Failed to set stp_task" if stp_task.nil?  
  
  @debug=stp_task.options[:debug]

  ## Set static vars
  rhevh_available = nil
  rhevh_powerstate = "Not Found in VMDB"
  hv_href =""
  
  ## Obtain vars from root set by the dialog	
  rhevh_name = stp_task.options[:rhevh_name]
  domain = stp_task.options[:domain]
  fqdn = "#{rhevh_name}#{domain}"
  #rhevh_available = $evm.vmdb('host').find_by_name(fqdn)
  rhevh_available = $evm.vmdb('host').find(:all)
  
  
  rhevh_available.each do |rhev|
    if (rhev['name'].match(/#{rhevh_name}.*/)) && (rhev['created_on'] > (Time.now - 60.minutes))
    	rhevh_powerstate = rhev.power_state unless rhev.nil?
        hv_href = rhev.ems_ref
	end
  end

  if rhevh_powerstate.eql?("pending_approval") 
    ## Setting hypervisor data to be used in state_machine
    #hv_href = rhevh_available.ems_ref
    hypervisor_data = { :hv_href => hv_href.to_s }
    $evm.log(:info, "PROV_LOG- Setting hypervisor_data to root: #{hypervisor_data.inspect}")
    stp_task.set_option(:hypervisor_data, hypervisor_data)
  else
    $evm.log(:info, "PROV_LOG- Waiting for #{fqdn} to become available")
    $evm.log(:info, "PROV_LOG- #{fqdn} powerstate = #{rhevh_powerstate}")
    $evm.root['ae_result']         = 'retry'
    $evm.root['ae_retry_interval'] = '120.seconds'    
  end
  
  exit MIQ_OK

rescue => err
  $evm.root['ae_result'] = 'error'
  $evm.root['ae_reason'] = "Caught exception in check_hypervisor_availability:#{err.class}:#{err}"
  $evm.log('error', "#{$evm.root['ae_reason']}")
end 
