#
# Description: this method will obtain options tagged in the provider
#
#
begin

  ## Set the serivce_template_provision_task
  stp_task = $evm.root['service_template_provision_task']
  raise "Failed to set stp_task" if stp_task.nil?  
  
  @debug=stp_task.options[:debug]

  ## Set local vars
  rhevh_name = nil
  rhevm_name = nil
  rhev_provider = nil
  redhat_cluster = nil
  os_version = nil
  primary_network = nil
  nfs_network = nil
 
  ## Obtain vars from root set by the dialog	
  rhevh_name = $evm.root['dialog_rhevh_name']
  raise "Failed to set rhevh_name" if rhevh_name.nil?
  $evm.log(:info, "PROV_LOG- Setting rhevh_name: #{rhevh_name}")
  stp_task.set_option(:rhevh_name, rhevh_name)  
  
  ## set the ips_registered_in_infoblox var
  ips_registered = $evm.root['dialog_ips_registered_in_infoblox']
  $evm.log(:info, "PROV_LOG_DEBUG- Setting ips_registered_in_infoblox: #{ips_registered}") if @debug
  stp_task.set_option(:ips_registered_in_infoblox, ips_registered)
  
  ## Obtain the redhat provider from the dialog  	
  provider_id = $evm.root['dialog_src_ems_id']
  $evm.log(:info, "PROV_LOG_DEBUG- Rhev Provider ID: #{provider_id}") if @debug

  ## Obtain the redhat cluster from the dialog  	
  cluster_id = $evm.root['dialog_cluster_name']
  $evm.log(:info, "PROV_LOG_DEBUG- cluster ID: #{cluster_id}") if @debug
  
  ## Select the Provider from the vmdb object
  rhev_provider = $evm.vmdb(:ext_management_system).find_by_id(provider_id)
  raise "Failed to set rhev_provider" if rhev_provider.nil?
  $evm.log(:info, "PROV_LOG_DEBUG- Setting rhev_provider: #{rhev_provider.name}") if @debug
  stp_task.set_option(:rhev_provider, rhev_provider)
  
  #get cluster object for the selected cluster
  redhat_cluster = $evm.vmdb('ems_cluster').find_by_id(cluster_id)
  raise "Failed to set redhat_cluster" if redhat_cluster.nil?
  $evm.log(:info, "PROV_LOG_DEBUG- Setting redhat_cluster: #{redhat_cluster.name}") if @debug  
  stp_task.set_option(:redhat_cluster, redhat_cluster)

  ## set the rhev manager name
  rhevm_name = redhat_cluster.ext_management_system.hostname
  raise "Failed to set rhevm_name from cluster:#{redhat_cluster.name}" if rhevm_name.nil?
  $evm.log(:info, "PROV_LOG_DEBUG- Setting rhevm_name: #{rhevm_name}") if @debug
  stp_task.set_option(:rhevm_name, rhevm_name)
 
  ## set the rhev manager userid
  rhevm_userid = redhat_cluster.ext_management_system.authentication_userid
  raise "Failed to set rhevm_userid from cluster:#{redhat_cluster.name}" if rhevm_userid.nil?
  $evm.log(:info, "PROV_LOG_DEBUG- Setting rhevm_userid: #{rhevm_userid}") if @debug
  stp_task.set_option(:rhevm_userid, rhevm_userid)

  ## set the rhev manager password
  rhevm_password = redhat_cluster.ext_management_system.authentication_password
  raise "Failed to set rhevm_password from cluster:#{redhat_cluster.name}" if rhevm_password.nil?
  $evm.log(:info, "PROV_LOG_DEBUG- Setting rhevm_password: #######") if @debug
  stp_task.set_option(:rhevm_password, rhevm_password)  
  
  ## set the os_version
  os_version = $evm.root['dialog_os_version']
  raise "Failed to set os_version" if os_version.nil?
  $evm.log(:info, "PROV_LOG_DEBUG- Setting os_version: #{os_version}") if @debug
  stp_task.set_option(:os_version, os_version)

  ## set the template
  new_ucs_sp_template = $evm.root['dialog_ucs_sp_template']
  raise "Failed to set new_ucs_sp_template" if new_ucs_sp_template.nil?
  $evm.log(:info, "PROV_LOG_DEBUG- Setting new_ucs_sp_template: #{new_ucs_sp_template}") if @debug
  stp_task.set_option(:new_ucs_sp_template, new_ucs_sp_template)  
  
  ## set primary_network
  primary_network = $evm.root['dialog_primary_vlan']
  raise "Failed to set primary_network" if primary_network.nil?
  $evm.log(:info, "PROV_LOG_DEBUG- Setting primary_network: #{primary_network}") if @debug
  stp_task.set_option(:primary_network, primary_network)
  
  ## set nfs_network
  nfs_network = $evm.root['dialog_nfs_vlan']
  raise "Failed to set nfs_network" if nfs_network.nil?
  $evm.log(:info, "PROV_LOG_DEBUG- Setting nfs_network: #{nfs_network}") if @debug
  stp_task.set_option(:nfs_network, nfs_network)    
  
rescue => err
  $evm.root['ae_result'] = 'error'
  $evm.root['ae_reason'] = "Caught exception in set_dialog_options:#{err.class}:#{err}"
  $evm.log('error', "#{$evm.root['ae_reason']}")
end  

