#
# Description: this method will obtain options tagged in the provider
#
#
begin
  
  ## Set the serivce_template_provision_task
  stp_task = $evm.root['service_template_provision_task']
  raise "Failed to set stp_task" if stp_task.nil?  
  
  @debug=stp_task.options[:debug]

  ## Set local vars
  data_center = nil
  cobbler = nil
  environment = nil
  ucs_mgr = nil
  network_location = nil
  
  ## Obtain domain from root
  domain = stp_task.options[:domain]
  
  ## Select the Provider from the vmdb object
  rhev_provider = stp_task.options[:rhev_provider]

  #get cluster object for the selected cluster
  redhat_cluster = stp_task.options[:redhat_cluster] 
  
  ## set the data_center var from tag
  data_center = rhev_provider.tags(:data_center).first
  raise "Failed to set data_center from provider tag" if data_center.nil?
  $evm.log(:info, "PROV_LOG- Setting data_center: #{data_center}")
  stp_task.set_option(:data_center, data_center)
  
  ## set the cobbler_host var from tag
  cobbler = rhev_provider.tags(:cobbler_host).first
  raise "Failed to set cobbler_host from provider tag" if cobbler.nil?  
  cobbler_host = "#{cobbler}#{domain}"
  $evm.log(:info, "PORV_LOG- Setting cobbler_host: #{cobbler_host}")
  stp_task.set_option(:cobbler_host, cobbler_host)

  ## set the environment var from tag
  environment = redhat_cluster.tags(:environment).first
  raise "Failed to set enviornment from cluster tag" if environment.nil?  
  $evm.log(:info, "PROV_LOG- Setting environment: #{environment}")
  stp_task.set_option(:environment, environment) 

  ## Obtain UCS manager from cluster tags
  ucs_mgr = redhat_cluster.tags(:ucs_manager).first
  raise "Failed to set ucs_manager from cluster tag" if ucs_mgr.nil?  
  $evm.log(:info, "PROV_LOG- Setting ucs_mgr: #{ucs_mgr}")
  stp_task.set_option(:ucs_manager, ucs_mgr)

  ## Obtain network_location from cluster tags
  network_location = redhat_cluster.tags(:network_location).first
  raise "Failed to set network_location from cluster tag" if network_location.nil?  
  $evm.log(:info, "PROV_LOG- Setting network_location: #{ucs_mgr}")
  stp_task.set_option(:network_location, network_location)
  
rescue => err
  $evm.root['ae_result'] = 'error'
  $evm.root['ae_reason'] = "Caught exception in set_tagged_options:#{err.class}:#{err}"
  $evm.log('error', "#{$evm.root['ae_reason']}")
end  

