begin
  prov = $evm.root['miq_provision']
  @debug = prov.options[:debug]
  
  vm = prov.destination if prov
  if vm
    power_state = vm.attributes['power_state']
    ems = vm.ext_management_system
    $evm.log('info', "VM:<#{vm.name}> on EMS:<#{ems ? ems.name : nil} has Power State:<#{power_state}>")
    if power_state == "on"
      $evm.root['ae_result'] = 'ok'
    elsif power_state == "never"
      $evm.root['ae_result'] = 'error'
      $evm.root['ae_reason'] = 'Attempting to power-on template'
    else
      vm.refresh
      $evm.root['ae_result']         = 'retry'
      $evm.root['ae_retry_interval'] = '15.seconds'
    end
  end
  exit MIQ_OK
  
rescue => err
  $evm.root['ae_result'] = 'error'
  $evm.root['ae_reason'] = "Failed to wait for VM start:#{err.class}:#{err}"
  $evm.log('error', "#{$evm.root['ae_reason']}")
end
