#
# Description: to get the hypervisory href
#
begin
  require 'restclient'
  require 'nokogiri'

#------------------------------------------------------------------------------
def call_rhev(servername, username, password, action, ref=nil, body_type=:xml, body=nil)
  #
  # If ref is a url then use that one instead
  #
  unless ref.nil?
	url = ref if ref.include?('http')
  end
	
  url ||= "https://#{servername}#{ref}"
	
  if @debug
	$evm.log(:info, "PROV_LOG_DEBUG- Calling RHEVM at: #{url}")
	$evm.log(:info, "PROV_LOG_DEBUG- Action: #{action}")
  end
	
  rest = RestClient::Request.new(
        :method => action,
        :url => url,
        :user => username,
        :password => password,
        :headers => { :content_type=> :xml, :accept=>:xml },
        :verify_ssl => false,
        :payload => body,
        :timeout => 300 )      
  
  response_str = rest.execute
  response_code = response_str.code
  response_str.gsub! '\"', '"'
  response_str.gsub! '\n', ''

  #$evm.log(:info, "xml - #{response_str}") if @debug   
  response = Nokogiri::XML(response_str)
  
  return response

rescue RestClient::Exception => err
  $evm.log(:info, "The REST request failed with code: #{err.response.code}") unless err.response.nil?
  $evm.log(:info, "The response body was:\n#{err.response.body.inspect}") unless err.response.nil?
  raise "rest call to rhevm failed:#{err.class}:#{err}"
rescue => err
    raise "call_rhev method failed:#{err.class}:#{err}"
end
#------------------------------------------------------------------------------
#------------------------------------------------------------------------------
# Start of main code
#------------------------------------------------------------------------------  
  ## Set the serivce_template_provision_task
  stp_task = $evm.root['service_template_provision_task']
  raise "Failed to set stp_task" if stp_task.nil?  
  
  @debug=stp_task.options[:debug]
    
  ## Localize vars pulled from root
  rhevh_name     = stp_task.options[:rhevh_name]  
  rhevm_name     = stp_task.options[:rhevm_name]
  rhevm_userid   = stp_task.options[:rhevm_userid]
  rhevm_password = stp_task.options[:rhevm_password]
  href = "/api/hosts"
    
  ## Validate the hypervisor_status
  doc = call_rhev(rhevm_name, rhevm_userid, rhevm_password, :get, "#{href}", :xml, nil)
  hv_href = doc.xpath("hosts/host[name='#{rhevh_name}']/@id").text	
    
    
  ## Setting hypervisor data to be used in state_machine
  hypervisor_data = { :hv_href => hv_href.to_s }
  $evm.log(:info, "PROV_LOG- Setting hypervisor_data to root: #{hypervisor_data.inspect}")
  stp_task.set_option(:hypervisor_data, hypervisor_data)
    
  exit MIQ_OK

rescue => err
  $evm.root['ae_result'] = 'error'
    $evm.root['ae_reason'] = "Caught exception in check_hypervisor_status:#{err.class}:#{err}"
  $evm.log('error', "#{$evm.root['ae_reason']}")
end
