#
# Description: this method will obtain the suitable App storage on additional disk.
#
begin
  
  @debug= $evm.object['debug']
  
  ## Obtain the redhat host from the dialog 	
  host_id = $evm.object['dialog_placement_host_name']

  ## space required - Hard coded for now
  req_stg = 73728 #MB  
  
  ## Add static vars
  rhev_stg = {}
  selected_storage = nil
  filtered_storages = []

  ## Determine if host_id is not nil and if not then load dropdown, otherwise load default val
  if !host_id.eql? nil
    $evm.log(:info, "Host ID: #{host_id}") if @debug
    
    ## Get host object for the selected host
    selected_host = $evm.vmdb('host').find_by_id(host_id)
    
    ## Filter storage selections by name
    if selected_host
      selected_host.storages.each { |stg|
        if stg.free_space.to_i < (req_stg.to_i * 1024 * 1024 )
          $evm.log(:info, "Skipping storage due to lack of free space: [#{stg.name}]") if @debug
         next
        end
        if stg.name =~ /_app_/
          $evm.log(:info, "Adding storage to filtered_storages: [#{stg.name}]") if @debug
          filtered_storages.push(stg) 
        end
      }
    end
  
    ## Choose the storage with the most free space
    if !filtered_storages.empty?
      selected_storage = filtered_storages.sort { |a,b| a.free_space <=> b.free_space }.last
      $evm.log(:info, "Selected Storage: #{selected_storage.name} id: #{selected_storage.id} ") if @debug
    end
  
    if !selected_storage.nil?
      storage_id =selected_storage.id
      storage_freespace = selected_storage.free_space.to_i / (1024 * 1024 * 1024)
      $evm.log(:info, "Selected Storage free space : #{storage_freespace} id: #{storage_id} ") if @debug
      ##Set the rhev_stg hash
      rhev_stg["0"] = 0 
      rhev_stg["#{storage_id}--025"] = 25
      rhev_stg["#{storage_id}--050"] = 50
      rhev_stg["#{storage_id}--075"] = 75 if storage_freespace.to_i > 75
      rhev_stg["#{storage_id}--100"] = 100 if storage_freespace.to_i > 100 
      rhev_stg["#{storage_id}--125"] = 125 if storage_freespace.to_i > 125
      rhev_stg["#{storage_id}--150"] = 150 if storage_freespace.to_i > 150
      rhev_stg["#{storage_id}--200"] = 200 if storage_freespace.to_i > 200
      rhev_stg["#{storage_id}--250"] = 250 if storage_freespace.to_i > 250
      rhev_stg["#{storage_id}--300"] = 300 if storage_freespace.to_i > 300
      rhev_stg["#{storage_id}--400"] = 400 if storage_freespace.to_i > 400
      rhev_stg["#{storage_id}--500"] = 500 if storage_freespace.to_i > 500
    end
  
    ## Set the dropdown list with the stg
    rhev_stg["0"] = "--No Suitable App Storage available--"  if rhev_stg.empty?
  else
    ## Set the dropdown list with the stg
    rhev_stg["0"] = "--Select App Storage Size--" 
  end
  
  $evm.object['values'] = rhev_stg.sort_by {|k,v| v}
  $evm.object["data_type"] = "string"
  $evm.object["sort_by"] = "value"
  $evm.log(:info, "Dropdown Values; #{rhev_stg.inspect}") if @debug
  
rescue => err
  (dbtype_hash||={})["#{err.class}: #{err}"] = "#{err.class}: #{err}"
  $evm.object['values'] = "#{err}"
  $evm.log(:error, "ERROR: Dynamic drop down values: #{dbtype_hash}")    
end 
