#
# Description: this method will obtain the suitable networks
#
begin
  
  @debug= $evm.object['debug']
  ## Obtain the redhat host from the dialog 	
  host_id = $evm.object['dialog_placement_host_name']
  
  # Preset vars
  nfs_networks = {}

  ## Determine if host_id is not nil and if not then set dropdown, otherwise set default val
  if !host_id.eql? nil
    $evm.log(:info, "Host ID: #{host_id}") if @debug
    
    ## get host object for the selected cluster
    selected_host = $evm.vmdb('host').find_by_id(host_id)
  
    ## Set the vlans based on the host selected
    if selected_host
      selected_host.lans.each { |network|
        if network.name =~ /nfs/
          nfs_networks["#{network.name}"] = "#{network.name}"
          $evm.log(:info, "network: #{network.name} id: #{network.id}") if @debug
        end
      }
    end
	
    ## Set the dropdown list with default val
    nfs_networks["0"] = "--No Suitable Networks available--"  if nfs_networks.empty?
  else
    ## Set the dropdown list with default val
    nfs_networks["0"] = "--Select nfs network--"  
  end
  
  $evm.object['values'] = nfs_networks
  $evm.log(:info, "Dropdown Values; #{nfs_networks.inspect}") if @debug
 
rescue => err
  (dbtype_hash||={})["#{err.class}: #{err}"] = "#{err.class}: #{err}"
  $evm.object['values'] = dbtype_hash
  $evm.log(:error, "ERROR: Dynamic drop down values: #{$evm.object['values']}")    
end 
