#
# Description: this method will obtain the suitable vlans 
#
begin
  @debug=$evm.object['debug']
  
  ## Obtain the puppet_profiles_list	
  puppet_profiles_array = $evm.root['puppet_profiles_array']

  # Preset vars
  puppet_profiles = {}

  ## Determine if the list is empty, and if it isn't load it into a hash, else set a default value.
  if ( !puppet_profiles_array.eql? nil && !puppet_profiles_array.empty? ) 
  $evm.log(:info, "Puppet Profiles Array: #{puppet_profiles_array.inspect}") if @debug
    
    ## Set profiles
    puppet_profiles_array.each { |profile|
      puppet_profiles["#{profile}"] = "#{profile}"
      $evm.log(:info, "Puppet Profile: #{profile}") if @debug
    }
      
  else
    ## Set the dropdown list with a default value
    puppet_profiles["0"] = "--ERROR - No Profiles Found --"
  end
  
  $evm.object['required'] = true  
  $evm.object['values'] = puppet_profiles
  $evm.log(:info, "Dropdown Values; #{puppet_profiles.inspect}") if @debug
 
rescue => err
  (dbtype_hash||={})["#{err.class}: #{err}"] = "#{err.class}: #{err}"
  $evm.object['values'] = dbtype_hash
  $evm.log(:error, "ERROR: Dynamic drop down values: #{$evm.object['values']}")    
end 
