#
# Description: this method will obtain all the rhev clusters for the provider selected
#
begin
  
  @debug= $evm.object['debug']
  
    
  ## Obtain the redhat Provider from the dialog
  provider_id = $evm.object['dialog_src_ems_id'] || nil
  environment = $evm.object['dialog_environment'] || nil
  network_location = $evm.object['dialog_network_location'] || nil

  ## set an emtpy has for the clusters
  rhev_clusters = {}
  
  ## Only execute the following code if provider_id is not nil
  if ( !provider_id.eql? nil) && ( !environment.eql? nil ) && ( !network_location.eql? nil )
    $evm.log(:info, "Provider ID: #{provider_id}") if @debug
  
    ## Select the Provider from the vmdb object
    rhev_provider = $evm.vmdb(:ext_management_system).find_by_id(provider_id)
  
    ##Loop through the clusters for the provider
    rhev_provider.ems_clusters.each { |redhat_cluster|
      if redhat_cluster.name =~ /Default/
        next
      end
      #for non sbx and Lab Env, select only dc02 clusters
      if rhev_provider.name !~ /SBX|LAB/ && redhat_cluster.name !~ /dc02/ 
        next
      end
      
      ##Find only clusters that have the proper environment tagged
      env = redhat_cluster.tags(:environment).first
      nl = redhat_cluster.tags(:network_location).first
      if ( env.eql?(environment) ) && ( nl.eql?(network_location) )
        rhev_clusters["#{redhat_cluster.id}"] = "#{redhat_cluster.name}"
        $evm.log(:info, "RHEV cluster: #{redhat_cluster.name} id: #{redhat_cluster.id}") if @debug
      end
    }
    
    # $evm.object['values'] = rhev_clusters
    list_values = {
       'sort_by'    => :value,
       'data_type'  => :string,
       'required'   => true,
       'values'     => rhev_clusters
    }
    list_values.each { |key, value| $evm.object[key] = value }
    $evm.log(:info, "Dropdown Values; #{rhev_clusters.inspect}") if @debug    
  end
  
rescue => err
  $evm.log(:error, "Caught exception in get_rhev_clusters:#{err.class}: #{err}")
end
