#
# Description: this method will obtain all the rhev environments by cluster
#
begin
  
  @debug= $evm.object['debug']
  
  ## Obtain the redhat Provider from the dialog
  provider_id = $evm.object['dialog_src_ems_id'] 

  ## set an emtpy has for the clusters
  rhev_environments = {}
  
  ## Only execute the following code if provider_id is not nil
  if (!provider_id.eql?(nil))
    $evm.log(:info, "Provider ID: #{provider_id}") if @debug
  
    ## Select the Provider from the vmdb object
    rhev_provider = $evm.vmdb(:ext_management_system).find_by_id(provider_id)
    $evm.log(:info, "Provider inspect: #{rhev_provider.inspect}") if @debug
    
    ##Loop through the clusters for the provider
    rhev_provider.ems_clusters.each { |redhat_cluster|
      $evm.log(:info, "redhat_cluster inspect: #{redhat_cluster.inspect}") if @debug
      if redhat_cluster.name =~ /Default/
        next
      end
      #for non sbx and Lab Env, select only dc02 clusters
      if rhev_provider.name !~ /SBX|LAB/ && redhat_cluster.name !~ /dc02/ 
        next
      end
      
      ## Get the environment from the cluster tag
      env = redhat_cluster.tags(:environment).first
      $evm.log(:info, "env: #{env}") if @debug
      
      ## only add the env if it not already in the list
      unless rhev_environments.has_key?(env)
        rhev_environments["#{env}"] = "#{env}" unless env.nil?
        $evm.log(:info, "RHEV env: #{env}") if @debug
      end
    }
  end

   # $evm.object['values'] = rhev_clusters
   list_values = {
    'sort_by'    => :value,
    'data_type'  => :string,
    'required'   => true,
    'values'     => rhev_environments
   }
   list_values.each { |key, value| $evm.object[key] = value }
   $evm.log(:info, "Dropdown Values; #{rhev_environments.inspect}") if @debug    
   
rescue => err
  (dbtype_hash||={})["#{err.class}: #{err}"] = "#{err.class}: #{err}"
  $evm.object['values'] = dbtype_hash
  $evm.log(:error, "ERROR: Dynamic drop down values: #{$evm.object['values']}")
end
