#
# Description: this method will obtain all the rhev providers cloudforms is connected to
#
begin

  @debug= $evm.object['debug']
  
  ## Initialize vars
  rhev_hash = {} 
  ## Loop through the vmdb and find all of the redhat providers
  $evm.vmdb(:ext_management_system).all.each { |ems_redhat|
    rhev_hash["#{ems_redhat.id}"] = "#{ems_redhat.name}"
    $evm.log(:info, "RHEV Datacenter: #{ems_redhat.name} id: #{ems_redhat.id}") if @debug
  }
 
  list_values = {
    'sort_by'    => :value,
    'data_type'  => :string,
    'required'   => true,
    'values'     => rhev_hash
    }
  list_values.each { |key, value| $evm.object[key] = value }
  $evm.log(:info, "Dropdown Values; #{rhev_hash.inspect}") if @debug
  
rescue => err
  (dbtype_hash||={})["#{err.class}: #{err}"] = "#{err.class}: #{err}"
  $evm.object['values'] = dbtype_hash
  $evm.log(:error, "ERROR: Dynamic drop down values: #{$evm.object['values']}")
end
