#
# Description: this method will obtain the suitable storage
#
begin
  
  @debug= $evm.object['debug']
  
  ## Obtain the redhat host from the dialog 	
  host_id = $evm.object['dialog_placement_host_name']
  
  #space required - Hard coded for now
  req_stg = 73728 #MB  
  
  ## Add static vars
  #rhev_stg = ""
  selected_storage = nil
  filtered_storages = []

  ## Determine if host_id is null and if not set dropdown, else set default val
  if !host_id.eql? nil
    $evm.log(:info, "Host ID: #{host_id}") if @debug
    
    ## Get host object for the selected host
    selected_host = $evm.vmdb('host').find_by_id(host_id)
    
    ## Filter storage selections by name
    if selected_host
      selected_host.storages.each { |stg|
        if stg.free_space.to_i < (req_stg.to_i * 1024 * 1024 )
          $evm.log(:info, "Skipping storage due to lack of free space: [#{stg.name}]") if @debug
          next
        end
        if stg.name =~ /_os_/
          $evm.log(:info, "Adding storage to filtered_storages: [#{stg.name}]") if @debug
          filtered_storages.push(stg) 
        end
      }
    end
  
    ## Choose the storage with the most free space
    selected_storage = filtered_storages.sort { |a,b| a.free_space <=> b.free_space }.last
   
    ##Set the rhev_stg hash
    if selected_storage 
    	 rhev_stg = "#{selected_storage.id}" 
   		 $evm.log(:info, "Selected Storage: #{selected_storage.name} id: #{selected_storage.id} ") if @debug
    end
  end

  $evm.object['required'] = true
  $evm.object['value'] = rhev_stg
  
rescue => err
  (dbtype_hash||={})["#{err.class}: #{err}"] = "#{err.class}: #{err}"
  #$evm.object['value'] = dbtype_hash
  $evm.log(:error, "ERROR: #{dbtype_hash}")    
end 
