#
# Description: this method will obtain the suitable vlans 
#
begin
  
  @debug=$evm.object['debug']
  
  ## Obtain the redhat host from the dialog 	
  host_id = $evm.object['dialog_placement_host_name'] || nil

  # Preset vars
  rhev_vlans = {}

  ## Determine if host_id is nil and set value if it is
  if !host_id.eql? nil
    $evm.log(:info, "Host ID: #{host_id}") if @debug

    ## get host object by host id
    selected_host = $evm.vmdb('host').find_by_id(host_id)
    
    ## Set the vlans based on the host selected
    if selected_host
      selected_host.lans.each { |vlan|
        if vlan.name =~ /tsm_|nfs_|rhevm/
           next
        end
        rhev_vlans["#{vlan.name}"] = "#{vlan.name}"
        $evm.log(:info, "vlan: #{vlan.name} id: #{vlan.id}") if @debug
      }
    end
    
  $evm.object['required'] = true
  $evm.object['values'] = rhev_vlans
  $evm.log(:info, "Dropdown Values; #{rhev_vlans.inspect}") if @debug    
  end
 
rescue => err
    $evm.log(:error, "ERROR: Dynamic drop down values: #{err.class}: #{err}")    
end 
