#
# Description: this method will obtain the suitable networks
#
begin
  
  @debug=$evm.object['debug']
  
  ## Obtain the redhat host from the dialog 	
  host_id = $evm.object['dialog_placement_host_name']

  ## Preset vars
  tsm_networks = {}

  ## Determine if host_id is nil and if it isnt load the dropdown, otherwise set a default val.
  if !host_id.eql? nil
    $evm.log(:info, "Host ID: #{host_id}") if @debug
    
    ## get host object by host id
    selected_host = $evm.vmdb('host').find_by_id(host_id)
  
    ## Set the vlans based on the host selected
    if selected_host
      selected_host.lans.each { |network|
        if network.name =~ /tsm/
          tsm_networks["#{network.name}"] = "#{network.name}"
          $evm.log(:info, "network: #{network.name} id: #{network.id}") if @debug
        end
      }
    end
    
	## Set the dropdown list with the vlans
    tsm_networks["0"] = "--No Suitable Networks available--"  if tsm_networks.empty?

  else
    tsm_networks["0"] = "--Select tsm network--"    
  end

  $evm.object['values'] = tsm_networks
  $evm.log(:info, "Dropdown Values; #{tsm_networks.inspect}") if @debug
 
rescue => err
  (dbtype_hash||={})["#{err.class}: #{err}"] = "#{err.class}: #{err}"
  $evm.object['values'] = dbtype_hash
  $evm.log(:error, "ERROR: Dynamic drop down values: #{$evm.object['values']}")    
end 
