#
# Description: this method will set the vm_name based on selections/tags
#
begin
  
  @debug= $evm.object['debug']
  
  ## Obtain the redhat Provider from the dialog
  provider_id = $evm.object['dialog_src_ems_id']
  environment = $evm.object['dialog_environment']
  cluster_id  = $evm.object['dialog_placement_cluster_name']
  app_id      = $evm.object['dialog_app_id']
  e_vm_name	  = $evm.object['dialog_vm_name']
  
  if (!provider_id.eql?(nil))
    $evm.log(:info, "Provider ID: #{provider_id}") if @debug
    ## Select the Provider from the vmdb object
    rhev_provider = $evm.vmdb(:ext_management_system).find_by_id(provider_id)
    
    ## Get the datacenter from the provider
    datacenter = rhev_provider.tags(:data_center).first
    dc = datacenter.slice(0, 2) unless datacenter.eql?(nil)
  end

  ## Set the hostname if all the vars are in place
  if (!dc.eql?(nil)) && (!app_id.empty?) && (!environment.eql?(nil) && (e_vm_name =~ /None/ || e_vm_name == '' ))
    vmname = "#{dc}#{app_id}#{environment}"
    #get all vms which matched above vmname,get the maximum number and append to the vmname
    vm_arr = []
    $evm.vmdb(:vm).all.each { |rhev_vm|
      if(rhev_vm.name =~ /^#{vmname}/)
        $evm.log(:info, "RHEV vm: #{rhev_vm.name} id: #{rhev_vm.id}") if @debug
        vm_num = rhev_vm.name.split(".").first
        vm_num.gsub!( /^#{vmname}/, '' )
        vm_arr << vm_num
      end
    }
    vm_arr.uniq!
    #if prd - check the cluster if odd or even and increment
    if(environment == 'prd')
    	arr_even=[]
		arr_odd=[]
      	vm_arr.each { |a|
           if(a.to_i.even? )
              arr_even << a
            else
              arr_odd << a
            end
        }
      cluster = $evm.vmdb(:ems_cluster).find_by_id(cluster_id).name
      if (cluster[-2,2] == "01")
      	vm_num = arr_odd.max
      else
      	vm_num = arr_even.max
      end
      vm_num = vm_num.to_i + 2	
    else
    	vm_num = vm_arr.max
    	vm_num = vm_num.to_i + 1
    end   ####end if prd
    vmname += vm_num.to_s
  else
	vmname = e_vm_name
  end

  list_values = {
    'data_type' => :string,
    'required'  => true,
    'value'     => vmname
  }
  list_values.each { |key, value| $evm.object[key] = value }
  
  $evm.log(:info, "Value: #{vmname}") if @debug
  
rescue => err
  $evm.log(:error, "Caught exception in set_vm_name:#{err.class}: #{err}")
end
