#
# Description: this method will obtain the rhev template 
#
#
begin
  
  @debug=$evm.root['debug']
 
  ## Obtain the redhat cluster from the dialog  	
  cluster_id = $evm.root['dialog_placement_cluster_name']
  $evm.log(:info, "PROV_LOG_DEBUG- cluster ID: #{cluster_id}") if @debug
 
  ## Preset vars
  selected_template = nil
  @task = $evm.root['service_template_provision_task']
  
  ## find the templates associated to the appropriate cluster
  ## Also finds the template with the proper name
  $evm.vmdb('miq_template').all.detect do | template |
    if "#{template.ems_cluster_id}" != "#{cluster_id}"
      next
    end
    $evm.log("info", "PROV_LOG_DEBUG- Found template: #{template.name}, Cluster ID = #{template.ems_cluster_id}, cluster- #{cluster_id}") if @debug
    if template.name =~ /_baseos/
      selected_template = template
    end
  end
  
  ## Set the template to the task object if its not nil
  raise "Unable to find suitable template" if selected_template.nil?
  $evm.log(:info, "PROV_LOG- selected Template: #{selected_template.name} id: #{selected_template.id}")
  @task.set_dialog_option('dialog_src_vm_id', selected_template.id)    
  
  exit MIQ_OK
  
rescue => err
  $evm.root['ae_result'] = 'error'
  $evm.root['ae_reason'] = "Caught exception in set_rhev_template:#{err.class}:#{err}"
  $evm.log('error', "#{$evm.root['ae_reason']}")
#  exit MIQ_ABORT
end 

