#
# Description: this method will obtain options tagged in the provider
#
#
begin
  
  @debug=$evm.root['debug']

  ## Set local vars
  data_center = nil
  cobbler = nil
  
  ## Obtain the redhat provider from the dialog  	
  provider_id = $evm.root['dialog_src_ems_id']
  $evm.log(:info, "PROV_LOG_DEBUG- Rhev Provider ID: #{provider_id}") if @debug

  ## Obtain the redhat cluster from the dialog  	
  cluster_id = $evm.root['dialog_placement_cluster_name']
  $evm.log(:info, "PROV_LOG_DEBUG- cluster ID: #{cluster_id}") if @debug
  
  ## Obtain domain from root
  domain = $evm.root['domain']
  
  ## Select the Provider from the vmdb object
  rhev_provider = $evm.vmdb(:ext_management_system).find_by_id(provider_id)

  #get cluster object for the selected cluster
  redhat_cluster = $evm.vmdb('ems_cluster').find_by_id(cluster_id)  
  
  ## Set the service template to a local var
  @task = $evm.root['service_template_provision_task']
  
  ## set the data_center var from tag
  data_center = rhev_provider.tags(:data_center).first
  raise "Failed to set data_center from provider tag" if data_center.nil?
  $evm.log(:info, "PROV_LOG- Setting data_center: #{data_center}")
  @task.set_dialog_option('dialog_data_center', data_center)  
  
  ## set the cobbler_host var from tag
  cobbler = rhev_provider.tags(:cobbler_host).first
  raise "Failed to set cobbler_host from provider tag" if cobbler.nil?  
  cobbler_host = "#{cobbler}#{domain}"
  $evm.log(:info, "PROV_LOG- Setting cobbler_host: #{cobbler_host}")
  @task.set_dialog_option('dialog_cobbler_host', cobbler_host)

   exit MIQ_OK
  
rescue => err
  $evm.root['ae_result'] = 'error'
  $evm.root['ae_reason'] = "Caught exception in set_tagged_options:#{err.class}:#{err}"
  $evm.log('error', "#{$evm.root['ae_reason']}")
  #exit MIQ_ABORT
end  

