#
# Description: This method updates the service provisioning status
# Required inputs: status
#

prov = $evm.root['service_template_provision_task']

# Get status from input field status
status = $evm.inputs['status']


# Update Status for on_entry,on_exit
if $evm.root['ae_result'] == 'ok' || $evm.root['ae_result'] == 'error'
  prov.message = status
  miq_request = prov.miq_request
  miq_request.user_message = "#{status}"
end

##also send the failure email message
@service = prov.destination
if @service && prov 
  if $evm.root['ae_result'] == 'error'
    vm_name = $evm.root['dialog_vm_name'] || prov.miq_request.options[:vm_name]  

    # If to is still nil use to_email_address from model
    to = nil
    to ||= $evm.root['user'].email
    to ||= "jake.millette@unionbank.com"

    # Get from_email_address from model unless specified below
    from = "cloudforms@unionbank.com"

    # Get signature from model unless specified below
    signature = "Virtualization Infrastructure Team"

    # Build subject
    subject = "Your Virtual Machine request is NOT completed - VM:#{vm_name}"

    # Build email body
    body = "Hello, "
    body += "<br>Your request to provision a virtual machine could not be completed and failed with following error: "
    body += "<br><br> #{status}" 
    body += "<br><br> Thank you,"
    body += "<br> #{signature}" 

    # Send email
    $evm.log("info", "PROV_LOG- Sending unsuccessful email to <#{to}> from <#{from}> subject: <#{subject}>")
    $evm.execute(:send_email, to, from, subject, body)

    ##delete the service
    #@service = prov.destination
    @service.remove_from_vmdb if @service && prov 
    $evm.log("info", "PROV_LOG- Removed the service")
   
  end
end
