
require 'restclient'
require 'nokogiri'

begin


def call_rhev(servername, username, password, action, ref=nil, body_type=:xml, body=nil)
	#
	# If ref is a url then use that one instead
	#
	unless ref.nil?
		url = ref if ref.include?('http')
	end
	
	url ||= "https://#{servername}#{ref}"
	$evm.log(:info, "Calling RHEVM at: #{url}")
	$evm.log(:info, "Action: #{action}")
  $evm.log(:info, "body: #{body}")
  header_option = { :accept=>:xml }
  if action == 'get'
      header_option = { :content_type=>:xml, :accept=>:xml }    
  end
  	rest = RestClient::Request.new(
          :method => action,
          :url => url,
          :user => username,
          :password => password,
          :headers => header_option,
    	  :verify_ssl => false,
          :payload => body)       
  #raise RestClient::RequestTimeout
  	response_str = rest.execute
  
  	response_str.gsub! '\"', '"'
  	response_str.gsub! '\n', ''

   # $evm.log(:info, "xml - #{response_str}")
    
  	response = Nokogiri::XML(response_str)
  
	return response
rescue RestClient::RequestTimeout
  $evm.log(:info, "Request was timed out but continuing.")
rescue RestClient::Exception => err
	$evm.log(:info, "The REST request failed with code: #{err.response.code}") unless err.response.nil?
	$evm.log(:info, "The response body was:\n#{err.response.body.inspect}") unless err.response.nil?
rescue => err
	$evm.log(:info, "[#{err}]\n#{err.backtrace.join("\n")}")
end

rhevh_name = 'chrvhtst2380' 
domain         = '.unionbank.com' 

####Find host in vmdb and delete in VMDB****
rhevh_available = nil
fqdn = "#{rhevh_name}#{domain}"
rhevh_available = $evm.vmdb('host').find_by_name(fqdn)

if rhevh_available.nil? 
  $evm.log(:info, "Host is not present in vmdb.")
else
  hv_href = rhevh_available.ems_ref
  $evm.log(:info, "host inspect: #{rhevh_available.inspect}")
  #rhevh_available.id.remove_from_vmdb
  ext = rhevh_available.scan
  $evm.log(:info, "hostext inspect: #{ext.inspect}")
  $evm.log(:info, "Host is present and removed from vmdb.")
end

############################################


servername = 'chrvmpte201.unionbank.com'
username = 'admin@internal'
password = 'rhevm@n@g3r'

 body = ""

ref = "/api/hosts"

$evm.log(:info, "servername: #{servername}")
$evm.log(:info, "username: #{username}")
$evm.log(:info, "password: #{password}")
$evm.log(:info, "body: #{body}")
$evm.log(:info, "ref: #{ref}")

## Localize vars pulled from root

fqdn           = "#{rhevh_name}#{domain}"  
rhevm_name     = 'chrvmpte201.unionbank.com' 
rhevm_userid   = 'admin@internal'
rhevm_password = 'rhevm@n@g3r'
#hv_href        = '/api/hosts/3d3f4a36-6d72-4bfb-8c59-354fcff50777' 

  missing_fields = ['rhevh_name', 'domain', 'rhevm_name', 'rhevm_userid', 'rhevm_password',
    'hv_href'].collect do | key |
    key unless eval(key)
  end.compact
  unless missing_fields.blank?
    raise "Missing required variables: [#{missing_fields}]" 
  end    

#rest api call to fetch host details
doc = call_rhev(rhevm_name, rhevm_userid, rhevm_password, :get, hv_href, :xml, nil)
if !doc
  $evm.log(:info, "No Host to delete")
else
	status = doc.xpath("host/status/state").text
	$evm.log(:info, "Host is present and the status is #{status}")
end

#rest api call to delete
#doc = call_rhev(rhevm_name, rhevm_userid, rhevm_password, :delete, hv_href, :xml, nil)


    
  

rescue => err
	$evm.log(:info, "[#{err}]\n#{err.backtrace.join("\n")}")
end
