
require 'restclient'
require 'nokogiri'

begin


def call_rhev(servername, username, password, action, ref=nil, body_type=:xml, body=nil)
	#
	# If ref is a url then use that one instead
	#
	unless ref.nil?
		url = ref if ref.include?('http')
	end
	
	url ||= "https://#{servername}#{ref}"
	$evm.log(:info, "Calling RHEVM at: #{url}")
	$evm.log(:info, "Action: #{action}")
  $evm.log(:info, "body: #{body}")
  
  	rest = RestClient::Request.new(
          :method => action,
          :url => url,
          :user => username,
          :password => password,
          :headers => { :content_type=> :xml, :accept=>:xml },
    	  :verify_ssl => false,
          :payload => body)       
  #raise RestClient::RequestTimeout
  	response_str = rest.execute
  
  	response_str.gsub! '\"', '"'
  	response_str.gsub! '\n', ''

   # $evm.log(:info, "xml - #{response_str}")
    
  	response = Nokogiri::XML(response_str)
  
	return response
rescue RestClient::RequestTimeout
  $evm.log(:info, "Request was timed out but continuing.")
rescue RestClient::Exception => err
	$evm.log(:info, "The REST request failed with code: #{err.response.code}") unless err.response.nil?
	$evm.log(:info, "The response body was:\n#{err.response.body.inspect}") unless err.response.nil?
rescue => err
	$evm.log(:info, "[#{err}]\n#{err.backtrace.join("\n")}")
end

servername = 'chrvmpte201.unionbank.com'
username = 'admin@internal'
password = 'rhevm@n@g3r'

vmname = 'chrvhdev221.unionbank.com'
 body = ""

ref = "/api/hosts"

$evm.log(:info, "servername: #{servername}")
$evm.log(:info, "username: #{username}")
$evm.log(:info, "password: #{password}")
$evm.log(:info, "body: #{body}")
$evm.log(:info, "ref: #{ref}")

## Localize vars pulled from root
### TST test
#rhevh_name     = 'chrvhtst238'
hv_href        = '/api/hosts/f7aae0e7-2e0d-450f-855e-a9cffe9bb738'
## Cluster01
#redhat_cluster = $evm.vmdb('ems_cluster').find_by_id('2000000000006')
## Cluster02
redhat_cluster = $evm.vmdb('ems_cluster').find_by_id('2000000000019')

### PTE test
rhevh_name     = 'chrvhpte242'

### UAT test
#rhevh_name     = 'chrvhuat238'
#redhat_cluster = $evm.vmdb('ems_cluster').find_by_id('2000000000020')
#hv_href        = '/api/hosts/8b512f91-eed5-44f5-8c4c-a7d4d7c71e31' 

domain         = '.unionbank.com' 
fqdn           = "#{rhevh_name}#{domain}"  
rhevm_name     = 'chrvmpte201.unionbank.com' 
rhevm_userid   = 'admin@internal'
rhevm_password = 'rhevm@n@g3r'
hv_href        = '/api/hosts/9de60a41-8d63-42ce-8351-b76f4b0fb948' 

  missing_fields = ['rhevh_name', 'domain', 'redhat_cluster', 'rhevm_name', 'rhevm_userid', 'rhevm_password',
    'hv_href'].collect do | key |
    key unless eval(key)
  end.compact
  unless missing_fields.blank?
    raise "Missing required variables: [#{missing_fields}]" 
  end    
  
  ## Get a list of hosts in the cluster
  hosts = redhat_cluster.hosts

  ## Raise an error if the 
  if hosts.blank?
    raise "This is the first hypervisor in the Cluster. Please manually configure hypervisor networks"
  end

  ## Loop through the hosts and pull the one that was last created
  hosts.delete_if {|obj| obj.power_state != "on"}
  if hosts.empty?
    raise "No usable hypervisor found for network template. Please manually configure hypervisor networks"
  end  
#$evm.log("info", "hosts : #{hosts.inspect}")
  hosts.sort_by! {|a| a.created_on}
  template_host = hosts[0]
#template_host= $evm.vmdb('host').find_by_name('chrvhtst249.unionbank.com')

  provision_host = $evm.vmdb('host').find_by_name(fqdn)
$evm.log("info", "template_host name: #{template_host.name}")
#$evm.log("info", "provision_host : #{provision_host.inspect}")

  nics = template_host.hardware.nics.sort_by! { |n| n.device_name.scan(/[0-9.]/).join.to_f }
  prov_nics = provision_host.hardware.nics.sort_by! { |n| n.device_name.scan(/[0-9.]/).join.to_f }

  ## Loop through the new nics and old nics and match them up amongst themselves.
  ## Then execute the rhev command to set the vlans on each appropriate network interface

#nics.each do |template_eth|      
#  $evm.log(:info, "nic: #{template_eth.device_name}" )
#  number = template_eth.device_name.scan(/[0-9.]/).join
#  $evm.log(:info, "nic number: #{number}" )
#  $evm.log(:info, "nic: #{template_eth.inspect}" )
#end


prov_count = 1
template_count = 0
#call from vmdb

#  prov_nics.each do |nic|
#    $evm.log(:info, "prov_nic: #{nic.device_name} count: #{prov_count}")
#    nics.each do |template_nic|      
#      if /\./.match(template_nic.device_name) && prov_count == template_count
#        request = "#{hv_href}/nics/#{nic.uid_ems}/attach"
#        body = "<action><network><name>#{template_nic.switch.name}</name></network></action>"
 #       $evm.log("info", "PROV_LOG- Configuring vlans-Template Host: #{template_host} - Template Nic:#{template_nic.device_name}")
 #       $evm.log("info", "PROV_LOG- request-prov Host: #{request}")
 #       $evm.log("info", "PROV_LOG- body-prov Host: #{body}")
 #       #$evm.log(:info, "   template_nic: #{template_eth.device_name}, template_count:#{template_count}" )  
 #     elsif /\./.match(template_nic.device_name)
 #      # $evm.log(:info, " skipping: #{template_nic.device_name}, template_count:#{template_count}" )  
 #       next  
 #     else
 #    # $evm.log(:info, " template_nic: #{template_nic.device_name} adding to count: #{template_count}")         
 #      template_count+= 1
 #    end
 #  end

#rest api call
hv_href = "#{hv_href}/nics"
doc = call_rhev(rhevm_name, rhevm_userid, rhevm_password, :get, hv_href, :xml, nil)
doc_root = doc.root

nic_arr =[]
  doc_root.xpath("host_nic").select{|nic|
  	nic_name=nic.at_xpath("name").text
    nic_uid =nic.at_xpath("actions/link[@rel='attach']/@href").text
     #doc.xpath("disk/link[@rel='creation_status']/@href").text
    nic_arr << {"device_name" =>"#{nic_name}" , "uid_ems" => "#{nic_uid}"}
}
$evm.log("info", "nic_arr inspect: #{nic_arr.inspect}") 
nic_arr.each do |nic|
  $evm.log("info", nic['device_name'])
end
nic_arr.sort_by! { |n| n['device_name'].scan(/[0-9.]/).join.to_f }

  nic_arr.each do |nic|
    $evm.log(:info, "prov_nic: #{nic['device_name']} count: #{prov_count}")
    nics.each do |template_nic|      
      if /\./.match(template_nic.device_name) && prov_count == template_count
        request = "#{nic['uid_ems']}"
        body = "<action><network><name>#{template_nic.switch.name}</name></network></action>"
        $evm.log("info", "PROV_LOG- Configuring vlans-Template Host: #{template_host} - Template Nic:#{template_nic.device_name}")
        $evm.log("info", "PROV_LOG- request-prov Host: #{request}")
        $evm.log("info", "PROV_LOG- body-prov Host: #{body}")
        #$evm.log(:info, "   template_nic: #{template_eth.device_name}, template_count:#{template_count}" )  
      call_rhev(rhevm_name, rhevm_userid, rhevm_password, :post, request, :xml, body)
      elsif /\./.match(template_nic.device_name)
        $evm.log(:info, " skipping: #{template_nic.device_name}, template_count:#{template_count}" )  
        next  
      else
       $evm.log(:info, " template_nic: #{template_nic.device_name} adding to count: #{template_count}")         
        template_count+= 1
      end
    end

   prov_count+= 1
   template_count = 0
  end

    
      
#      if template_eth.device_name.match(eth.device_name) && /\./.match(template_eth.device_name)
#        request = "#{hv_href}/nics/#{eth.uid_ems}/attach"
#        body = "<action><network><name>#{template_eth.switch.name}</name></network></action>" 
#        $evm.log("info", "#{request}")
#        $evm.log("info", "#{body}")
        ## Call RHEV to configure the network vlans on the interface
#        $evm.log("info", "PROV_LOG- Configuring vlans-Template Host: #{template_host} - Template Nic:#{template_eth.device_name}")
        #call_rhev(rhevm_name, rhevm_userid, rhevm_password, :post, request, :xml, body)
#      end
#  

rescue => err
	$evm.log(:info, "[#{err}]\n#{err.backtrace.join("\n")}")
end
