#
# Description: <Method description here>
#
begin
  ## Set the serivce_template_provision_task
  #stp_task = $evm.root['service_template_provision_task']
  #raise "Failed to set stp_task" if stp_task.nil?  
  
  #@debug=stp_task.options[:debug]
  @debug=1
  
  require 'restclient'
  require 'rexml/document'

  ## Instantiate local vars
  cookie = nil
  
  ## UCS credentials pulled from schema
  #ucs_user = $evm.object['ucs_user']
  #ucs_pw   = $evm.object.decrypt('ucs_pw')
  #$evm.log(:info,"PROV_LOG_DEBUG- ucs_user:#{ucs_user} ucs_pw:######" ) if @debug
  ## Obtain vars from root
  #ucs_mgr = stp_task.options[:ucs_manager]
  #rhevh_name = stp_task.options[:rhevh_name]

  ## Hardcoded vars
  ucs_user = $evm.object['ucs_user']
  ucs_pw   = $evm.object.decrypt('ucs_pw')
  ucs_mgr = 'chucspte002.unionbank.com'
  rhevh_name = 'chrvhdev241'
  action = $evm.inputs['action']
  blade_dn = 'sys/chassis-9/blade-2'
  sp_dn = "org-root/org-Linux/ls-SP_#{rhevh_name}"
  
  if action == 'enable'
    status = 'created'
  elsif action == 'disable'
    status = 'deleted'
  end

  ## Obtain the system date
  time = Time.new
  system_time = time.strftime "%Y-%m-%dT%H:%M:%S"  
  
  ## Object array to enable/disable
  ucs_dn_entries = [ sp_dn, blade_dn ]
    
  ## Construct the restclient object to use for connecting to ucs
  ucs_conn = RestClient::Resource.new( "https://#{ucs_mgr}", :ssl_version => 'TLSv1', :verify_ssl => false, :content_type => 'text/xml' )

  ## login to UCS and retrieve the session cookie
  $evm.log(:info,"PROV_LOG_DEBUG- Logging in to UCS: #{ucs_mgr}") if @debug
  begin
    resp = ucs_conn['/nuova'].post(
      "<aaaLogin inName='#{ucs_user}' inPassword='#{ucs_pw}'/>" )
      $evm.log(:info,"PORV_LOG_DEBUG- UCS Login response: #{resp}") if @debug      
      cookie = REXML::Document.new(resp).root.attributes['outCookie']
  rescue => e
    raise("Failed to login to #{ucs_mgr}:[#{e}]")
  end
    $evm.log(:info,"PROV_LOG_DEBUG- UCS session cookie: #{cookie}") if @debug

  ### Loop through the DN array to enable/disable fault suppression
  ucs_dn_entries.each do |dn_entry|
    
    ## Set the command
    query = "<configConfMo cookie='#{cookie}' dn='#{dn_entry}/fault-suppress-task-maint-server' inHierarchical='false'>
                <inConfig>
                   <faultSuppressTask adminState='untriggered'
                     descr='Ugrading Hypervisor to latest release'
                     dn='#{dn_entry}/fault-suppress-task-maint-server'
                     name='maint-server'
                     policyOwner='local'
                     scheduler=''
                     status='#{status}'
                     suppressPolicyName='default-server-maint'>
                     <trigLocalSched
                        adminState='untriggered'
                        descr=''
                        policyOwner='local'
                        rn='local-sched-default'>
                        <trigLocalAbsWindow
                          concurCap='unlimited'
                          date='#{system_time}'
                          procBreak='none'
                          procCap='unlimited'
                          rn='local-abs-default'
                          timeCap='00:00:30:00.0'>
                        </trigLocalAbsWindow>
                     </trigLocalSched>
                   </faultSuppressTask>
                </inConfig>
             </configConfMo>"

    ## Execute rest call to UCS xml api
#    $evm.log(:info,"PROV_LOG- UCS-[#{rhevh_name}]: query for #{dn_entry}: #{query}")    
    begin
      $evm.log(:info,"PROV_LOG- UCS-[#{rhevh_name}]: #{action} fault suppression on ucs object:#{dn_entry}")
      resp = ucs_conn['/nuova'].post("#{query}")
      xmldoc = REXML::Document.new(resp)
    rescue => e
      raise("[#{rhevh_name}]-Failed to #{action} fault suppression on ucs object via #{ucs_mgr}:[#{e}]")
    end
  end  
  
  exit MIQ_OK

rescue => err
  $evm.root['ae_result'] = 'error'
  $evm.root['ae_reason'] = "Caught exception in change_fault_supression:#{err.class}:#{err}"
  $evm.log('error', "#{$evm.root['ae_reason']}")
ensure
  ## logout from UCS
  $evm.log(:info, "PROV_LOG- Logging out from UCS ...") unless cookie.eql?(nil)
  begin
    ucs_conn['/nuova'].post(
      "<aaaLogout inCookie='#{cookie}'/>" ) unless cookie.eql?(nil)
  rescue => e
    $evm.log(:error, "PROV_LOG- Failed to logout from #{ucs_mgr}:[#{e}]")
  end
end
