#
# Description: <Method description here>
#
begin
  ## Set the serivce_template_provision_task
  #stp_task = $evm.root['service_template_provision_task']
  #raise "Failed to set stp_task" if stp_task.nil?  
  
  #@debug=stp_task.options[:debug]
  @debug=1
  
  require 'restclient'
  require 'rexml/document'

  ## Instantiate local vars
  blades = {}
  cookie = nil
  
  ## UCS credentials pulled from schema
  #ucs_user = $evm.object['ucs_user']
  #ucs_pw   = $evm.object.decrypt('ucs_pw')
  #$evm.log(:info,"PROV_LOG_DEBUG- ucs_user:#{ucs_user} ucs_pw:######" ) if @debug
  ## Obtain vars from root
  #ucs_mgr = stp_task.options[:ucs_manager]
  #rhevh_name = stp_task.options[:rhevh_name]

  ## Hardcoded vars
  ucs_user = $evm.object['ucs_user']
  ucs_pw   = $evm.object.decrypt('ucs_pw')
  ucs_mgr = 'chucspte002.unionbank.com'
  rhevh_name = 'chrvhdev241'
  sp = 'SP_chrvhdev241'
  action = $evm.inputs['action']
  
  if action == 'reset_disk'
    sp_template = 'SPT_RHEV_reinitialize_disk'
    sp_template_old = 'SPT_RHEV_DEV_B'
  elsif action == 'new_template'
    sp_template_old = 'SPT_RHEV_reinitialize_disk'
    sp_template = 'SPT_RHEV_DEV_B'  
  end
  
  ## Service Profile DN
  rhevh_DN = "org-root/org-Linux/ls-SP_#{rhevh_name}"
    
  ## Construct the restclient object to use for connecting to ucs
  ucs_conn = RestClient::Resource.new( "https://#{ucs_mgr}", :ssl_version => 'TLSv1', :verify_ssl => false, :content_type => 'text/xml' )

  ## login to UCS and retrieve the session cookie
  $evm.log(:info,"PROV_LOG_DEBUG- Logging in to UCS: #{ucs_mgr}") if @debug
  begin
    resp = ucs_conn['/nuova'].post(
      "<aaaLogin inName='#{ucs_user}' inPassword='#{ucs_pw}'/>" )
      $evm.log(:info,"PORV_LOG_DEBUG- UCS Login response: #{resp}") if @debug      
      cookie = REXML::Document.new(resp).root.attributes['outCookie']
  rescue => e
    raise("Failed to login to #{ucs_mgr}:[#{e}]")
  end
    $evm.log(:info,"PROV_LOG_DEBUG- UCS session cookie: #{cookie}") if @debug

  ## Set the command
  query = "<configConfMo dn='#{rhevh_DN}' cookie='#{cookie}'>
             <inConfig> 
               <lsServer srcTemplName='#{sp_template}' status='modified'/>
             </inConfig>
           </configConfMo>"

  ## Execute rest call to UCS xml api
  begin
    $evm.log(:info,"PROV_LOG- UCS - Changing #{sp} template from #{sp_template_old} to #{sp_template}")
    resp = ucs_conn['/nuova'].post("#{query}")
    xmldoc = REXML::Document.new(resp)
     
  rescue => e
    raise("Failed to change #{sp} template from #{sp_template_old} to #{sp_template} via #{ucs_mgr}:[#{e}]")
  end
  
  exit MIQ_OK

rescue => err
  $evm.root['ae_result'] = 'error'
  $evm.root['ae_reason'] = "Caught exception in change_service_profile_template:#{err.class}:#{err}"
  $evm.log('error', "#{$evm.root['ae_reason']}")
ensure
  ## logout from UCS
  $evm.log(:info, "PROV_LOG- Logging out from UCS ...") unless cookie.eql?(nil)
  begin
    ucs_conn['/nuova'].post(
      "<aaaLogout inCookie='#{cookie}'/>" ) unless cookie.eql?(nil)
  rescue => e
    $evm.log(:error, "PROV_LOG- Failed to logout from #{ucs_mgr}:[#{e}]")
  end
end
