#
# Description: <Method description here>
#
begin
  ## Set the serivce_template_provision_task
  #stp_task = $evm.root['service_template_provision_task']
  #raise "Failed to set stp_task" if stp_task.nil?  
  
  #@debug=stp_task.options[:debug]
  @debug=1
  
  require 'restclient'
  require 'rexml/document'

  ## Instantiate local vars
  blades = {}
  cookie = nil
  
  ## UCS credentials pulled from schema
  #ucs_user = $evm.object['ucs_user']
  #ucs_pw   = $evm.object.decrypt('ucs_pw')
  #$evm.log(:info,"PROV_LOG_DEBUG- ucs_user:#{ucs_user} ucs_pw:######" ) if @debug
  ## Obtain vars from root
  #ucs_mgr = stp_task.options[:ucs_manager]
  #rhevh_name = stp_task.options[:rhevh_name]

  ## Hardcoded vars
  ucs_user = $evm.object['ucs_user']
  ucs_pw   = $evm.object.decrypt('ucs_pw')
  ucs_mgr = 'chucspte002.unionbank.com'
  rhevh_name = 'chrvhdev241'
  search_success = false
  action = $evm.inputs['action']
  
  ## validate based on the action selecte
  if action == 'changed_template' or action == 'associated'
    ## Used to validate that the template change is complete
    rhevh_DN = "org-root/org-Linux/ls-SP_#{rhevh_name}"
    items = [{ :name => 'configState', :value => 'applied'},{ :name => 'assocState', :value => 'associated' }]
    objectType = 'lsServer'
  elsif action == 'disassociated'
    ## Used to validate that the service profile was disassociated from the blade
    rhevh_DN = 'sys/chassis-9/blade-2'
    items = [{ :name => 'association', :value => 'none'},{ :name => 'availability', :value => 'available' }]
    objectType = 'computeBlade'
  end
      
  ## Construct the restclient object to use for connecting to ucs
  ucs_conn = RestClient::Resource.new( "https://#{ucs_mgr}", :ssl_version => 'TLSv1', :verify_ssl => false, :content_type => 'text/xml' )

  ## login to UCS and retrieve the session cookie
  $evm.log(:info,"PROV_LOG_DEBUG- Logging in to UCS: #{ucs_mgr}") if @debug
  begin
    resp = ucs_conn['/nuova'].post(
      "<aaaLogin inName='#{ucs_user}' inPassword='#{ucs_pw}'/>" )
      $evm.log(:info,"PORV_LOG_DEBUG- UCS Login response: #{resp}") if @debug      
      cookie = REXML::Document.new(resp).root.attributes['outCookie']
  rescue => e
    raise("Failed to login to #{ucs_mgr}:[#{e}]")
  end
    $evm.log(:info,"PROV_LOG_DEBUG- UCS session cookie: #{cookie}") if @debug

  ## Set the command
  query = "<configResolveDn cookie='#{cookie}' dn='#{rhevh_DN}' inHierarchical='false' />"

  ## Execute rest call to UCS xml api
  max_count = 30
  count = 0
  while not search_success
    counter += 1
    if counter == max_count
      raise "Timed out waiting for #{rhevh_DN} items to match expected values:'#{items}'"
    else    
      begin
        $evm.log(:info,"PROV_LOG- UCS - Validating #{rhevh_DN} #{action} for Items:#{items}")
        $evm.log(:info,"PROV_LOG- UCS - Count is #{count} of #{max_count}")        
      resp = ucs_conn['/nuova'].post("#{query}")
      xmldoc = REXML::Document.new(resp)
    
      items.each do |item|
        $evm.log(:info,"PROV_LOG_DEBUG- UCS - Working on #{item[:name]} = #{item[:value]}" ) if @debug   
        ## Grab the actual value of the element from the XML
        item_value = xmldoc.elements["configResolveDn/outConfig/#{objectType}"].attributes["#{item[:name]}"]
        $evm.log(:info,"PROV_LOG_DEBUG- Object #{item[:name]} = #{item_value}" ) if @debug        
         
        ## Determine if they equal what we are looking for
        if item_value != item[:value]
          $evm.log(:info,"PROV_LOG_DEBUG- UCS - Object #{item[:name]} should be #{item[:value]} but is #{item_value}...waiting") if @debug
          search_success = false
          sleep 60
          break
        else
          $evm.log(:info,"PROV_LOG_DEBUG- UCS - Object #{item[:name]}: #{item[:value]} matches #{item_value}") if @debug
          search_success = true
        end
      end
       
      rescue => e
        raise("Failed to validate #{rhevh_DN} #{action} for items:#{items} via #{ucs_mgr}:[#{e}]")
      end
    end
  end

  $evm.log(:info,"PROV_LOG- UCS - Successfully Validated #{rhevh_DN} #{action} for Items:#{items}")
  exit MIQ_OK

rescue => err
  $evm.root['ae_result'] = 'error'
$evm.root['ae_reason'] = "Caught exception in validate_ucs_object_status:#{err.class}:#{err}"
  $evm.log('error', "#{$evm.root['ae_reason']}")
ensure
  ## logout from UCS
  $evm.log(:info, "PROV_LOG- Logging out from UCS ...") unless cookie.eql?(nil)
  begin
    ucs_conn['/nuova'].post(
      "<aaaLogout inCookie='#{cookie}'/>" ) unless cookie.eql?(nil)
  rescue => e
    $evm.log(:error, "PROV_LOG- Failed to logout from #{ucs_mgr}:[#{e}]")
  end
end
